<template>
  <div class="login-container">
    <el-form
      ref="loginForm"
      :model="loginForm"
      :rules="loginRules"
      class="login-form"
      auto-complete="on"
      label-position="left"
    >
      <h3 class="title">公共资源平台</h3>
      <el-form-item prop="username" label="账号">
        <!--<span class="svg-container svg-container_login">
          <svg-icon icon-class="user"/>
        </span>-->
        <el-input
          v-model="loginForm.username"
          ref="userNameInput"
          name="username"
          type="text"
          auto-complete="on"
          placeholder="请输入账号"
          @keyup.enter.native="handleLogin"
        />
      </el-form-item>
      <el-form-item prop="password" label="密码">
       <!-- <span class="svg-container">
          <svg-icon icon-class="password"/>
        </span>-->
        <el-input
          :type="pwdType"
          v-model="loginForm.password"
          name="password"
          auto-complete="on"
          placeholder="请输入密码"
          @keyup.enter.native="handleLogin"
        />
        <span class="show-pwd" @click="showPwd">
          <svg-icon v-if="eyeIsOpen" icon-class="eye"/>
          <svg-icon v-else icon-class="eye-open"/>
        </span>
      </el-form-item>

      <!--<el-form-item prop="verifycode" label="验证码">
        <el-col :span="14">
        <div>
          <el-input
            v-model="loginForm.verifycode"
            name="verifycode"
            auto-complete="on"
            placeholder="请输入验证码"
            @keyup.enter.native="handleLogin"
          />
        </div>
        </el-col>
        <el-col :span="6">
          <div class="identifybox" @click="refreshCode" style="height: 40px">
            <sidentify :identifyCode="identifyCode"></sidentify>
          </div>
        </el-col>
      </el-form-item>-->

      <!--<el-checkbox v-model="loginForm.isRememberMe" style="margin:0px 0px 25px 0px;"><span style="color: #eee">七天免登录</span></el-checkbox>-->

      <el-form-item>
        <el-button
          :loading="loading"
          type="primary"
          style="width:100%;"
          @click.native.prevent="handleLogin"
        >登 录</el-button>
      </el-form-item>
    </el-form>

    <!--引入粒子特效-->
    <vue-particles
      color="#fff"
      :particleOpacity="0.7"
      :particlesNumber="60"
      shapeType="circle"
      :particleSize="4"
      linesColor="#fff"
      :linesWidth="1"
      :lineLinked="true"
      :lineOpacity="0.4"
      :linesDistance="150"
      :moveSpeed="2"
      :hoverEffect="true"
      hoverMode="grab"
      :clickEffect="true"
      clickMode="push"
      class="lizi"
    >
    </vue-particles>
  </div>
</template>

<script>
import { isvalidUsername } from "@/utils/validate";
import {getWebSiteName} from '@/api/login'

import sidentify from './sidentify'
import CheckPhoto from "../../components/CheckPhoto/index";
export default {
  components: {
    sidentify
  },
  name: "Login",
  data() {
    const validateUsername = (rule, value, callback) => {
      if (value.length < 1) {
        callback(new Error('账号必填'))
      } else {
        callback()
      }
    };
    const validatePass = (rule, value, callback) => {
      if (value.length < 1) {
        callback(new Error("密码必填"));
      } else {
        callback();
      }
    };
    const validateVerifycode = (rule, value, callback) => {
      if (value.length < 1) {
        callback(new Error("验证码必填"));
      } else {
        callback();
      }
    };
    return {
      loginForm: {
        username: "",
        password: "",
        verifycode: "",
        isRememberMe: false,
      },
      eyeIsOpen: true,
      identifyCodes: "1234567890",
      identifyCode: "",
      webSiteName: "",
      loginRules: {
        username: [
          { required: true, trigger: "blur", validator: validateUsername }
        ],
        password: [{ required: true, trigger: "blur", validator: validatePass }],
        verifycode: [{ required: true, trigger: "blur", validator: validateVerifycode }]
      },
      loading: false,
      pwdType: "password",
      redirect: undefined,
    };
  },
  watch: {
    // $route: {
    //   handler: function(route) {
    //     this.redirect = route.query && route.query.redirect;
    //   },
    //   immediate: true
    // }
  },
  mounted() {
    // mounted钩子函数，dom已经渲染完毕，可以直接获取到dom对象进行聚焦
    this.$refs.userNameInput.focus();
    this.identifyCode = "";
    this.makeCode(this.identifyCodes, 6)
  },
  created() {
    // created，dom还未开始渲染，因此需要使用this.$nextTick 将其放置在下一个dom渲染操作时执行
    // this.$refs.userNameInput.focus()
    this.getWebName();
    this.refreshCode();
  },
  methods: {
    getWebName: function () {
      getWebSiteName().then(response => {
        if(response.code == this.$ECode.SUCCESS) {
          this.webSiteName = response.data
        }
      });
    },
    inputFocus: function() {
      this.$nextTick(x => {
        this.$refs.userNameInput.focus()
      })
    },
    showPwd() {
      if (this.pwdType === "password") {
        this.pwdType = "";
        this.eyeIsOpen = false;
      } else {
        this.pwdType = "password";
        this.eyeIsOpen = true;
      }
    },
    handleLogin() {

      this.$refs.loginForm.validate(valid => {
        if (valid) {
          /*if (this.loginForm.verifycode != this.identifyCode){
            this.$message.error("验证码错误");
            this.identifyCode = "";
            this.makeCode(this.identifyCodes, 6)
          }else {*/
            this.loading = true;
            this.$store
              .dispatch("Login", this.loginForm)
              .then(response => {
                if (response.code == this.$ECode.SUCCESS) {
                  this.$router.push({ path: this.redirect || "/" });
                } else {
                  this.identifyCode = "";
                  this.makeCode(this.identifyCodes, 6)
                  this.$message.error(response.data);
                }
                this.loading = false;
              })
              .catch(() => {
                this.loading = false;
              });
          }
        /*}else {
          console.log("error submit!!");
          this.identifyCode = "";
          this.makeCode(this.identifyCodes, 6)
          return false;
        }*/
      });
    },

    refreshCode(){
      this.identifyCode = "";
      this.makeCode(this.identifyCodes, 6);
    },
    makeCode(o, l){
      for(let i = 0; i < l; i++){
        this.identifyCode += this.identifyCodes[
          this.randomNum(0, this.identifyCodes.length)
          ];
      }
    },
    randomNum(min, max){
      return Math.floor(Math.random() * (max - min) + min)
    }

  }
};
</script>

<style rel="stylesheet/scss" lang="scss">
$bg: #2d3a4b;
$light_gray: #eee;

/* reset element-ui css */
.login-container {
  .el-input {
    display: inline-block;
    height: 47px;
    width: 85%;
    input {
      background: transparent;
      border: 0px;
      -webkit-appearance: none;
      border-radius: 0px;
      padding: 12px 5px 12px 15px;
      color: $light_gray;
      height: 47px;
      &:-webkit-autofill {
        -webkit-box-shadow: 0 0 0px 1000px $bg inset !important;
        -webkit-text-fill-color: #fff !important;
      }
    }
  }
  .el-form-item {
    border: 1px solid rgba(255, 255, 255, 0.1);
    background: rgba(0, 0, 0, 0.1);
    border-radius: 5px;
    color: #454545;
  }
}
</style>

<style rel="stylesheet/scss" lang="scss" scoped>
$bg: #2d3a4b;
$dark_gray: #889aa4;
$light_gray: #eee;
.login-container {
  position: fixed;
  height: 100%;
  width: 100%;
  background-color: $bg;
  .login-form {
    position: absolute;
    left: 0;
    right: 0;
    width: 520px;
    max-width: 100%;
    padding: 35px 35px 15px 35px;
    margin: 120px auto;
  }
  .tips {
    font-size: 14px;
    color: #fff;
    margin-bottom: 10px;
    span {
      &:first-of-type {
        margin-right: 16px;
      }
    }
  }
  .svg-container {
    padding: 6px 5px 6px 15px;
    color: $dark_gray;
    vertical-align: middle;
    width: 30px;
    display: inline-block;
    &_login {
      font-size: 20px;
    }
  }
  .title {
    font-size: 26px;
    font-weight: 400;
    color: $light_gray;
    margin: 0px auto 40px auto;
    text-align: center;
    font-weight: bold;
  }
  .show-pwd {
    position: absolute;
    right: 10px;
    top: 7px;
    font-size: 16px;
    color: $dark_gray;
    cursor: pointer;
    user-select: none;
  }
}
</style>
